# Copyright 2017 GSI, Inc. All rights reserved.
#
#
include(GetPrerequisites)

# WORKAROUND: if "macro" is used it doesn't outoup "message" messages.
#macro(DDS_CollectPrerequisites)
	
	###################################################
	## Collect prerequisites for WN PKG
	###################################################
	message( STATUS "Using BOOST Library dir: " /Users/anar/Development/BOOST/lib)
	string(REPLACE "::" ";" PREREQ_DIRS_LIST /Users/anar/Development/BOOST/lib::/Users/anar/Development/DDS-buildbot/slave/RELEASE/build/build/dds-user-defaults::/Users/anar/Development/DDS-buildbot/slave/RELEASE/build/build/dds-protocol-lib::/Users/anar/Development/DDS-buildbot/slave/RELEASE/build/build/dds-intercom-lib::/Users/anar/Development/DDS-buildbot/slave/RELEASE/build/build/dds-topology-lib::/Users/anar/Development/DDS-buildbot/slave/RELEASE/build/build/MiscCommon/dds_ncf::)
	message( STATUS "prerequisite dirs: " "${PREREQ_DIRS_LIST}")
	
	# WORKAROUND: the list comes broken into the macro, we need to rebuild it
	# if we don't do that, the  get_prerequisites doesn't use all avaliable directories.
	# I didn't find anyother way, but rebuilt the list.
	set(PREREQ_DIRS_LIST_REBUILT "")
	foreach(dir ${PREREQ_DIRS_LIST})
	     # message(STATU "DEBUG: " ${dir})
		 LIST(APPEND PREREQ_DIRS_LIST_REBUILT ${dir})
	 endforeach()

	get_prerequisites(/Users/anar/Development/DDS-buildbot/slave/RELEASE/build/build/dds-commander/dds-commander DEPENDENCIES 1 1 "" "${PREREQ_DIRS_LIST_REBUILT}")

	
	foreach(DEPENDENCY_FILE ${DEPENDENCIES})
		# get file name to be able to resolve files with @rpath on macOS
		get_filename_component(PREREQNAME "${DEPENDENCY_FILE}"  NAME)
	  	gp_resolve_item(/Users/anar/Development/DDS-buildbot/slave/RELEASE/build/build/dds-commander/dds-commander "${PREREQNAME}" "" "${PREREQ_DIRS_LIST_REBUILT}" resolved_file)
		# link only third-party libs
		# Skip DDS libs
		if(${PREREQNAME} MATCHES "^libboost_*")
			#	file(COPY ${resolved_file} DESTINATION /tmp/DDS_INSTALL/lib)
			message("DDS Commander prerequisite: creating a symlink: /tmp/DDS_INSTALL/lib/${PREREQNAME} -> ${resolved_file}")
			execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${resolved_file} "/tmp/DDS_INSTALL/lib/${PREREQNAME}")
		else()
			message("DDS Commander prerequisite: skipping: ${PREREQNAME}")
		endif()
	endforeach()
	###################################################

#endmacro(DDS_CollectPrerequisites)
